  #include <LiquidCrystal.h>
  
  LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
  
  unsigned char alarm=0;
  unsigned char czas=0;
 
    
    
  void setup() 
  {
    lcd.begin(16, 2);
    pinMode(10,OUTPUT); //wyjście sterujące podświetleniem LCD
    pinMode(2, OUTPUT); // wyjście buzzera
    tone(2,500,30);     // wygenerowanie tonu 500Hz przez 30mS
    digitalWrite(10,LOW); //wygaś LCD
    delay(100); //opóźnienie 0,1 s 
    noTone(2);            //wycisz ewentualne dźwięki
    digitalWrite(10,HIGH); //włącz LCD
    licz();   
  }
  
  
  void licz()
  {
    for (czas=59; czas>0; czas--) //zmniejszanie czas o 1 aż do 0
    {
      lcd.setCursor(0,0);
      lcd.print("Nagrzewanie...");
      lcd.setCursor(0,1);
      lcd.print("Pozostalo: ");
      lcd.print (czas);
      lcd.print(" s");
      delay(1000);
      lcd.clear();
     }
    lcd.clear();
    czas=0;
  }
  
  void loop() 
  {
    int sensorValue = analogRead(A1);
    float voltage = sensorValue * (5.00 / 1023.0);
    lcd.setCursor(0,0);  
    lcd.print("Czujnik GAZU LPG ");
    lcd.print(voltage);
    lcd.setCursor (0,1);
    lcd.print("                ");
    lcd.setCursor(0,1);
 
    switch(alarm)
    {
      case 0:
        lcd.print("Poziom normalny");
        break;
      case 1:
        lcd.print("Poziom >100ppm");
        czas=0;
        break;
      case 2:
        lcd.print("Poziom >1000ppm");
        czas=0;
        break;
      case 3:
        lcd.print("Poziom >10000ppm");
        czas=0;
        break;
   }
  
  
  
     if (czas > 100 && alarm == 0)
     {
        digitalWrite(10, LOW);      
     }
      
      else
      {
        czas++;
        digitalWrite(10,HIGH);
      }
  
  
    delay(50);
    
    
   
    if(voltage > 0.49 && voltage <1.18)
    {
      alarm=1;
      tone(2,500,200);
      delay(300);
    }

   if(voltage > 1.18 && voltage <2.1)
    {
     alarm=2;
     tone(2,500,200);
     delay(150);
    }
    
    if (voltage > 2.1 && voltage < 5)
    {
      alarm=3;
      tone(2,500,200);
      delay(50);
    }
  
  
    if (voltage<0.49) 
    {
      noTone(2);
      alarm=0;
    }
    
    
  }
  
  

